diff --git a/libr/core/file.c b/libr/core/file.c
index 04698e53e300d..a56b34c2dee7b 100644
--- a/libr/core/file.c
+++ b/libr/core/file.c
@@ -519,18 +519,20 @@ R_API int r_core_bin_rebase(RCore *core, ut64 baddr) {
 	return 1;
 }
 
-R_API int r_core_bin_load(RCore *r, const char *filenameuri, ut64 baddr) {
+R_API bool r_core_bin_load(RCore *r, const char *filenameuri, ut64 baddr) {
 	const char *suppress_warning = r_config_get (r->config, "file.nowarn");
 	RCoreFile *cf = r_core_file_cur (r);
 	RBinFile *binfile = NULL;
-	RIODesc *desc = cf? cf->desc: NULL;
 	RBinPlugin *plugin = NULL;
 	int is_io_load;
+	if (!cf) {
+		return false;
+	}
 	// NULL deref guard
-	if (!desc) {
+	if (!cf->desc) {
 		is_io_load = false;
 	} else {
-		is_io_load = desc && desc->plugin;
+		is_io_load = cf->desc && cf->desc->plugin;
 	}
 
 	if (cf) {
@@ -557,19 +559,18 @@ R_API int r_core_bin_load(RCore *r, const char *filenameuri, ut64 baddr) {
 	r->bin->maxstrbuf = r_config_get_i (r->config, "bin.maxstrbuf");
 	if (is_io_load) {
 		// TODO? necessary to restore the desc back?
-		// RIODesc *oldesc = desc;
 		// Fix to select pid before trying to load the binary
-		if ((desc->plugin && desc->plugin->isdbg) || r_config_get_i (r->config, "cfg.debug")) {
+		if ((cf->desc->plugin && cf->desc->plugin->isdbg) || r_config_get_i (r->config, "cfg.debug")) {
 			r_core_file_do_load_for_debug (r, baddr, filenameuri);
 		} else {
 			ut64 laddr = r_config_get_i (r->config, "bin.laddr");
 			r_core_file_do_load_for_io_plugin (r, baddr, laddr);
 		}
 		// Restore original desc
-		r_io_use_desc (r->io, desc);
+		r_io_use_desc (r->io, cf->desc);
 	}
-	if (cf && binfile && desc) {
-		binfile->fd = desc->fd;
+	if (cf && binfile && cf->desc) {
+		binfile->fd = cf->desc->fd;
 	}
 	binfile = r_bin_cur (r->bin);
 	if (r->bin->cur && r->bin->cur->curplugin && r->bin->cur->curplugin->strfilter) {
diff --git a/libr/debug/meson.build b/libr/debug/meson.build
index df0911f1b77fb..9043780dc84d4 100644
--- a/libr/debug/meson.build
+++ b/libr/debug/meson.build
@@ -64,7 +64,7 @@ r_debug = shared_library('r_debug', files,
   platform_librinc
   ]),
   c_args : ['-DCORELIB=1', '-I' + meson.current_build_dir() + '/../..'],
-  link_with: [r_util, r_hash, r_reg, r_syscall, r_anal, r_flag, r_io, r_bp, r_search, r_cons, r_lang],
+  link_with: [r_util, r_hash, r_reg, r_syscall, r_anal, r_flag, r_io, r_bp, r_search, r_cons, r_lang, r_egg],
   objects: [
     r_sdb.extract_all_objects(),
   ],
diff --git a/libr/include/r_core.h b/libr/include/r_core.h
index a6c8c8d94d1c5..99cad9eb092e2 100644
--- a/libr/include/r_core.h
+++ b/libr/include/r_core.h
@@ -409,7 +409,7 @@ R_API int r_core_bin_set_env (RCore *r, RBinFile *binfile);
 R_API int r_core_bin_set_by_fd (RCore *core, ut64 bin_fd);
 R_API int r_core_bin_set_by_name (RCore *core, const char *name);
 R_API int r_core_bin_reload(RCore *core, const char *file, ut64 baseaddr);
-R_API int r_core_bin_load(RCore *core, const char *file, ut64 baseaddr);
+R_API bool r_core_bin_load(RCore *core, const char *file, ut64 baseaddr);
 R_API int r_core_bin_rebase(RCore *core, ut64 baddr);
 R_API void r_core_bin_export_info_rad(RCore *core);
 R_API int r_core_hash_load(RCore *core, const char *file);
